#include "flush.h"
#include <qradiobutton.h>
#include <qmessagebox.h>

void Flush::slot_fire()
{
	if(hosts->isOn())
	{
		if(mysql_query(mysql,"flush hosts"))
	    {
	        QMessageBox::critical(this, tr("MySQL Navigator"), QString::fromLocal8Bit(mysql_error(mysql)));
	   		emit signal_error(); 
		}
		else
		{
	        QMessageBox::information(this, tr("MySQL Navigator"), tr("Flush hosts succeeded."));
		}
	}
	else if(logs->isOn())
	{
		if(mysql_query(mysql,"flush logs"))
	    {
	        QMessageBox::critical(this, tr("MySQL Navigator"), QString::fromLocal8Bit(mysql_error(mysql)));
	   		emit signal_error(); 
	    }
		else
		{
	        QMessageBox::information(this, tr("MySQL Navigator"), tr("Flush logs succeeded."));
		}
	}
	else if(status->isOn())
	{
		if(mysql_query(mysql,"flush status"))
	    {
	        QMessageBox::critical(this, tr("MySQL Navigator"), QString::fromLocal8Bit(mysql_error(mysql)));
	   		emit signal_error(); 
	    }
		else
		{
	        QMessageBox::information(this, tr("MySQL Navigator"), tr("Flush status succeeded."));
		}
	}
	else if(tables->isOn())
	{
		if(mysql_query(mysql,"flush tables"))
	    {
	        QMessageBox::critical(this, tr("MySQL Navigator"), QString::fromLocal8Bit(mysql_error(mysql)));
	   		emit signal_error(); 
		}
		else
		{
	        QMessageBox::information(this, tr("MySQL Navigator"), tr("Flush tables succeeded."));
		}
	}
	else if(privilages->isOn())
	{
		if(mysql_query(mysql,"flush privileges"))
	    {
	        QMessageBox::critical(this, tr("MySQL Navigator"), QString::fromLocal8Bit(mysql_error(mysql)));
	   		emit signal_error(); 
		}
		else
		{
	        QMessageBox::information(this, tr("MySQL Navigator"), tr("Flush privileges succeeded."));
		}
	}
}

void Flush::slot_close()
{
	parentWidget()->close();
}

void Flush::slot_about()
{
	QMessageBox::information(this, tr("MySQL Navigator"), tr("This is a flush window."));
}
